function [S, SHz, Sbins] = FindSkyPosAndFDotSValue(xAccOverc,yAccOverc,zAccOverc,RA_sky,Dec_sky,f0,fDot,duration,tbase)
% Usage: [S, SHz, Sbins] = FindSkyPosAndFDotSValue(xAccOverc,yAccOverc,zAccOverc,RA_sky,Dec_sky,f0,fDot,duration,tbase)
theta_sky = (pi/2.0) - Dec_sky;
nx = sin(theta_sky)*cos(RA_sky);
ny = sin(theta_sky)*sin(RA_sky);
nz = cos(theta_sky);
aDotnOc = xAccOverc*nx + yAccOverc*ny + zAccOverc*nz;
S = aDotnOc*f0 + fDot;
SHz = S*duration;
Sbins = S*duration*tbase;